#if!defined (_diagonalization_h_)
#include <assert.h>
#include <math.h>
#define _diagonalization_h_
#include "sector.h"
#include "quantum_operator.h"

extern "C" int dsyev_ (char *jobz, 
		       char *uplo, 
		       int *n, 
		       double *fa, 
		       int *lda, 
		       double *w, 
		       double *work, 
		       int *lwork, 
		       int *info); 

void block_hamiltonian_diagonalization(int sector_no, 
				       sector_properties * sectors_properties_array, 
				       quantum_operator & block_hamiltonian, 
				       sector * transformation_sectors, 
				       double * new_block_energies_array); 



#endif //diagonalization.h

