#if!defined (_state_list_h_)

#define _state_list_h_

#include<fstream>
#include<iostream>
using namespace std;

#include "state.h"


/**************************************************************
class state_item 
represents a given state within a linked list of states. 
**************************************************************/

class state_item {
 protected:
  state_item * next_ptr;
  friend class linked_state_list;

 public:
  state new_state;

  state_item();
  ~state_item();
};

/**************************************************************
class linked_state_list
represents a list of linked states. 

**************************************************************/


class linked_state_list{
 public: 
  state_item * first_ptr;

  linked_state_list(); 
  ~linked_state_list(); 
  void add_state(state &); 
  state & get_state(state_item * ); 
  state_item * get_next_ptr(state_item *); 
};

#endif 
